param([string] $action, [string] $activate)

# Global variables for the script
$solutionName             = "DocuSign_1.5.1.0.wsp"
$solutionGuid             = "ac24cec7-548b-4572-aa3f-b13d60d42df7"
$solutionId               = "541d1d83-e843-401d-a2d2-3c414a860378"
$currentDirectory         = Get-Location
$maxRetries               = 100
$dsAccountConfigListName  = "DocuSign Account Configuration"
$dsUserConfigListName     = "DocuSign User"
$SPAdminServiceName       = "SharePoint 2010 Administration"
$docuSignKey              = (212,75,97,120,129,36,205,127,250,142,233,184,109,15,65,162,160,178,181,50,234,72,209,69,33,225,228,165,235,113,121,188)
$docuSignSOAP             = @"
76492d1116743f0423413b16050a5345MgB8AEgANABhADEAcABKADQAbQBVAEoAaABWAGkATABpAFAAVgBRAGIAeQBpAGcAPQA9AHwAYwBlADcANgAxAGEANAA4ADUAYgA0ADQAMgAyAGYAMAA2ADMANwBlADEANwA5ADMAMwBkAD
IAYwBiADcAMgBmAGMAMQAwAGEANABmADMAMwAzADYAZQBiADYAYQBmAGUANQAwAGQAMQAzADAAMgBhADQANAA2ADkAMgA0AGQAOABlADUANQAxADcAYwAwADMAZAAyAGIAYwBhADEANQAzAGUANwAwADUAMwBjAGEAOQA3ADUANwBh
AGMAMwBkAGMAZAA4AGEAZQBiAGUAMQBhAGYAOAAyADUAYQAyADcAMgBiADkANQA0ADYAYwAwADIAZABiADYAZAA0ADMAZQA4ADgANwA3AGUAMABkAGEAZQA0ADAAMwA3AGYANwBlAGYAZAAwADgAYwA5AGUAMAA4AGYAYQA3AGUAMQ
BkADUAZgAwADkAOAAwADEANgBlADUANgAwADAAYQBiADAANAAwAGUAYwA5AGEAYwBjADkAMgBjADkAZQAwAGYAYwA2AGQANABlADEANwAwAGMAMAAxADIAZgBlADMAYQA5ADcAMwAxAGQAYgAyAGIANgBiADMANQBmADAAOAAyAGMA
NQAxAGUAOQA2ADYANABiADMAMwAyADMANgAxAGEAOQA5AGMANwAxAGMAYgA2AGEAYQA4AGUANwBjADkAYwA1AGEAOAA5ADYAYQA5AGQAZgAzAGYAMQAyADMAOQBkADgANAA2ADkAMQBjADYAOQAzAGQANQAzADYAOABiAGIANgA5AD
kAZAA2ADUAMgBiAGIAYwA3AGIAZgAwAGYAZQA2ADYAYQA3ADYAMAAyADcAYgA5AGQAMwAwAGMAMQAwAGMAYQA1ADUANAA4ADcAYwA5ADMAYwBmAGMAOABhADUAMAAwADQAMABkADYAZgA2ADIANQAwADIAMABmADQAYQA1ADAAMQAy
AGEAMQBkAGIAMQBiAGYAYQAzADQAMwAzAGYAYgA0ADcANQBhADAAZQAyAGQAZQBiAGYAOAAyADEAOABiADcAMwA1AGEAOQBmAGEANQA3ADAAZgAzADEAZAA2ADEANgBiAGIANAA0AGQAZgA3ADMANQBkAGYAYgAzADAAYwBmADkANg
BjADYAYQBjAGUAMwBmADcAOQA1AGUAYwBlAGIAOABjADcAMgA1AGIAMgAyAGQAOABhADAAYQAwADYANQA4ADUAMQBmADAAYQBmADAANgA4ADMAMwBhADYAMQAyADIAMAAwAGEAYgA0AGIAMgBiADkAZABmAGQAMwBlADcAOAA3ADcA
ZQA3ADEAMwAxADcAOAA2ADMAYwBmADAANABkADgAYwBlAGMANQA4ADYAMwBlAGUAZgA1AGMANQBiADcAYwAyADgAMgBhADMAOAA4AGQAMgAwADEANwA5AGMAOQBkADMAYwA3ADQANgAyADYAMAA3ADcAZgA0AGMAYwAwAGIAYgBkAD
AANwA4ADYAMwAyADEANQA3ADEANQBiAGQAMwBhAGEAMAA4ADUAMwBjAGEAZQAxADUAOAA4ADEAZAAyAGIAYwA4AGYAZgBjAGYAMABhADQANQAwADEAZAA5AGYAZgAxADQAZAA0AGEAZgAxADUAMABlADAANgA5ADAANgBkAGEAMQA3
AGEANQAwADkAYQBjADEANwA5AGYAMwBlADMAYQBmAGEAMwBhAGUAYQBiAGYAMABjADcAMABhAGIAZgBiAGMANQA4ADUAZAA5ADAAYwBiADYAZAAyAGYAZgBmADUAOAAxAGIAOQA3AGIAOQAyADcAOQBmADUAZAA1ADAAYgA4ADIAOA
BiADYANQAwADUAZQBiAGIAOQA1ADUAZQA3AGUAOQA3AGUAZAA1ADUAZgBiAGIAMAA3AGIANQAyADIANABhAGEAMwAwADIANQAwAGQAMQA2ADkAMABlADMAMAA5ADIAZgAxADQAZAAzADQAZQBlAGMAMgBjADgAYwAyADYAYgAwADcA
ZgA3ADYAMgA4ADUAZABiADcANgBkADgAOQBkAGMAOQA1AGMAZgA2ADkAMgBmADcAMAA4ADkANgAyAGYANABkADYAYwBmAGUAMAA4AGIANgAxAGEAMABjAGUAMwA4AGMAZAAxADkAZAA3ADQAZgBiADMAZABmADIANwBiADQAMQA4AD
MAZgAyAGYAMQBhADUAOAA3AGUAOAA1ADAAOAAwAGYANwAwAGIAMQAwADAAYwA2ADAAMgBlAGQAMABkAGEAMgA3AGMAMwA5AGIAMAAxAGEAMgBhAGEAOAAxAGEAZABlADgAZABlADIAMgBhAGQAYQAxADIANQAyAGQANABkADUAYwAw
ADMAZgAzADQAZAAzAGYAOQBlADUAMABlADIAMABhADcAZQA1ADgAMwA3AGEANwA0AGIAMgBhADUAMAAzADIAYwAyADkAMAA3AGEAMwA1AGEAZAA3AGEANQBiADQAOQBkAGUANgBjADYAMQAwADIAMwAwADEAMQBjAGUAYQBiADEANw
AyAGYAZgAwADgAZgA0ADMAZAA2ADMAOAA5ADcAMgBlADQAZQAwAGEAZgA3ADUAZgA3ADEAOAAxAGUAOQA0ADAANQBmAGEAMwAyAGYANAA4ADMANAA5AGEAOQA2ADgAZgBlADEANwA4ADgANwA0ADgAZgAxADIAMgAzADcANAAyADAA
NABlAGUAOQBkAGMAMgBlADUAZgAxADYAMAAzADgAMAA2ADgAZgBjAGUANQAwAGMAZABiAGYANgA2ADYAYgBhADYAMgBlADIANQBiADYAZgAzAGMAOAA4ADYAYwAyADUANQA5ADUAYwBiAGYAOABjAGIAZABkADMAOQA1ADIAOABmAD
AAMwBiAGEAZABiAGEANwBmADMANgBmAGEANwAyADAAYgBmAGYANQBiADcAZAA0AGMAOQAyAGEANAA1AGUAOABmADMAZgBkADcAYQAwAGIAYwA1ADkAYgBiAGUAMgAyADUANgA=
"@

$docuSign_DS_RIBBON_BUTTON_CREATION_COMMAND = @'
    <CommandUIExtension>
      <CommandUIDefinitions>
        <CommandUIDefinition Location="Ribbon.Documents.Scaling._children">
            <MaxSize Id="Ribbon.Documents.Scaling.DocuSign.MaxSize"
                     Sequence="600"
                     GroupId="Ribbon.Documents.DocuSign"
                     Size="LargeMedium" />
        </CommandUIDefinition>
        <CommandUIDefinition Location="Ribbon.Documents.Scaling._children">
          <Scale Id="Ribbon.Documents.Scaling.DocuSign.Scale"
                   Sequence="610"
                   GroupId="Ribbon.Documents.DocuSign"
                   Size="LargeSmall" />
        </CommandUIDefinition>
        <CommandUIDefinition Location="Ribbon.Documents.Scaling._children">
          <Scale Id="Ribbon.Documents.Scaling.DocuSign.Popup"
                   Sequence="620"
                   GroupId="Ribbon.Documents.DocuSign"
                   Size="Popup" />
        </CommandUIDefinition>
        <CommandUIDefinition
          Location="Ribbon.Documents.Groups._children">
          <Group
            Id="Ribbon.Documents.DocuSign"
            Sequence="100"
            Description="DocuSign Group"
            Title="DocuSign"
            Template="Ribbon.Templates.Flexible2">
            <Controls Id="Ribbon.Documents.DocuSign.Controls">
              <Button Id="Ribbon.Documents.DocuSign.SendWithDocuSignButton"
                      Sequence="10"
                      Command="SendWithDocuSignCommand"
                      Description="Send document(s) for signature with DocuSign"
                      LabelText="Send With DocuSign"
                      Image16by16="/_layouts/images/DocuSignFeatureReceiver/DSIcon16x16.gif"
                      Image32by32="/_layouts/images/DocuSignFeatureReceiver/DSIcon32x32.gif"
                      ToolTipTitle="Send with DocuSign"
                      ToolTipDescription="Click to send the selected document(s) to DocuSign for signature."
                      TemplateAlias="o1" />
              <Button Id="Ribbon.Documents.DocuSign.SignWithDocuSign"
                      Sequence="20"
                      Command="SignWithDocuSignCommand"
                      Description="Sign documents with DocuSign"
                      LabelText="Sign With DocuSign"
                      Image16by16="/_layouts/images/DocuSignFeatureReceiver/DSIcon16x16.gif"
                      Image32by32="/_layouts/images/DocuSignFeatureReceiver/DSIcon32x32.gif"
                      ToolTipTitle="Sign with DocuSign"
                      ToolTipDescription="Click to sign the selected document(s)."
                      TemplateAlias="o2" />
              <Button Id="Ribbon.Documents.DocuSign.UpdateDocuSignEnvelopeStatusButton"
                      Sequence="30"
                      Command="ViewDocuSignEnvelopeStatusCommand"
                      Description="View DocuSign envelope status"
                      LabelText="View Status"
                      Image16by16="/_layouts/images/DocuSignFeatureReceiver/DSIcon16x16.gif"
                      Image32by32="/_layouts/images/DocuSignFeatureReceiver/DSIcon32x32.gif"
                      ToolTipTitle="View Envelope Status"
                      ToolTipDescription="Click to view the status of DocuSign envelopes."
                      TemplateAlias="o2" />
              <FlyoutAnchor
                Id="Ribbon.Documents.DocuSign.More"
                Sequence="40"
                ToolTipTitle=""
                ToolTipDescription=""
                LabelText="More..."
                Image16by16="/_layouts/images/DocuSignFeatureReceiver/DSIcon16x16.gif"
                Image32by32="/_layouts/images/DocuSignFeatureReceiver/DSIcon32x32.gif"
                PopulateDynamically="false"
                TemplateAlias="o2"
              >
                <Menu Id="Ribbon.Documents.DocuSign.More" >
                  <MenuSection
                    Id="Ribbon.Documents.DocuSign.More.Section"
                    Sequence="10"
                    DisplayMode="Menu16">
                    <Controls Id="Ribbon.Documents.DocuSign.More.Controls">
                      <Button Id="Ribbon.Documents.DocuSign.ResetDocuSignConfigurationButton"
                              Sequence="10"
                              Command="ResetDocuSignConfigurationCommand"
                              Description="Update DocuSign settings and configuration"
                              LabelText="Settings"
                              Image16by16="/_layouts/images/DocuSignFeatureReceiver/DSIcon16x16.gif"
                              Image32by32="/_layouts/images/DocuSignFeatureReceiver/DSIcon32x32.gif"
                              ToolTipTitle="Update DocuSign Settings"
                              ToolTipDescription="Click to delete DocuSign account, user and status records or change the DocuSign environment."
                              TemplateAlias="o2" />
                      <Button Id="Ribbon.Documents.DocuSign.CredentialsButton"
                              Sequence="20"
                              Command="ManageDocuSignIdentityCommand"
                              Description="Specify DocuSign account/login credentials"
                              LabelText="Credentials"
                              Image16by16="/_layouts/images/DocuSignFeatureReceiver/DSIcon16x16.gif"
                              Image32by32="/_layouts/images/DocuSignFeatureReceiver/DSIcon32x32.gif"
                              ToolTipTitle="Credentials"
                              ToolTipDescription="Click to set or change your DocuSign login credentials."
                              TemplateAlias="o2" />

                    </Controls>
                  </MenuSection>
                </Menu>
              </FlyoutAnchor>
            </Controls>
          </Group>
        </CommandUIDefinition>
      </CommandUIDefinitions> 
      <CommandUIHandlers>
        <CommandUIHandler Command="SendWithDocuSignCommand"             CommandAction="javascript:docusign_SendWithDocuSign()"          EnabledScript="javascript:docusign_EnableSendWithDocuSign()" />
        <CommandUIHandler Command="SignWithDocuSignCommand"             CommandAction="javascript:docusign_SignWithDocuSign()"          EnabledScript="javascript:docusign_EnableSignWithDocuSign()" />
        <CommandUIHandler Command="ViewDocuSignEnvelopeStatusCommand"   CommandAction="javascript:docusign_ViewEnvelopeStatus()"        EnabledScript="javascript:docusign_EnableViewStatus()" />
        <CommandUIHandler Command="ResetDocuSignConfigurationCommand"   CommandAction="javascript:docusign_resetDocuSignConfiguration()"  EnabledScript="javascript:docusign_EnableResetConfiguration()" />
        <CommandUIHandler Command="ManageDocuSignIdentityCommand"       CommandAction="javascript:docusign_SetCredentials()"              EnabledScript="javascript:docusign_EnableCredentials()" />
      </CommandUIHandlers>
    </CommandUIExtension>
'@


$usageInfo                = @"
Usage:
`n
NAME
    DocuSignInstall.ps1
`n  
SYNOPSIS
    Installs, updates or uninstalls the DocuSign feature for SharePoint.
`n
SYNTAX
    DocuSignInstall -action [install | update | uninstall | displayconfig | updateconfig] [-activate `$true | `$false]
`n
DESCRIPTION
    The DocuSignInstall script is used to install, update or uninstall the DocuSign feature for SharePoint.
`n
    An action must be specified - either install, update, uninstall, displayconfig or updateconfig.
`n
    If the action is install or update, the activate parameter must be specified.
    If activate is true the DocuSign feature will be activated for all sites in SharePoint.
    If activate is false then no activation or deactivation action will be taken.
`n
    For uninstall action, the DocuSign feature is deactivated in all sites before the feature is uninstalled.
`n
    displayconfig will list the DocuSign feature's status and account credentials for all sites
`n
    updateconfig will set/update the account credentials for the specified sites (deleting existing account and user
    credentials in the process).
`n
EXAMPLES
    DocuSignInstall.ps1 -action install -activate `$true
    DocuSignInstall.ps1 -action update  -activate `$false
    DocuSignInstall.ps1 -action uninstall
    DocuSignInstall.ps1 -action displayconfig
    DocuSignInstall.ps1 -action updateconfig
"@


# Returns the DocuSign site to use
Function GetSiteName([String] $docuSignEnvironment)
{
   if ($docuSignEnvironment.ToLower() -eq "production")
   {
      $docuSignURL = "https://www.docusign.net/api/3.0/AccountManagement.asmx"
   }
   elseif ($docuSignEnvironment.ToLower() -eq "test")
   {
      $docuSignURL = "https://test.docusign.net/api/3.0/AccountManagement.asmx"
   }
   elseif ($docuSignEnvironment.ToLower() -eq  "preview")
   {
      $docuSignURL = "https://preview.docusign.net/api/3.0/AccountManagement.asmx"
   }
   elseif ($docuSignEnvironment.ToLower() -eq "demo")
   {
      $docuSignURL = "https://demo.docusign.net/api/3.0/AccountManagement.asmx"
   }
   else
   {
      $docuSignURL = "https://www.docusign.net/api/3.0/AccountManagement.asmx"
      write-host "Unknown environment: $docuSignEnvironment.  Defaulting to production."
   }
   return $docuSignURL
}


Function DecryptString( [String] $stringToDecrypt )
{
   $secureStr    = convertto-securestring -string $stringToDecrypt -key $docuSignKey
   $decryptedStr = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($secureStr))
   return $decryptedStr
}


Function Execute-SOAPRequest( [String] $docuSignUserName,
                              [String] $docuSignPassword,
                              [Xml]    $SOAPRequest,
                              [String] $soapAction,
                              [String] $url ) 
{ 
   $soapWebRequest = [System.Net.WebRequest]::Create($url) 
   $soapWebRequest.Headers.Add("SOAPAction", $soapAction)

   $soapWebRequest.ContentType = "text/xml;charset=`"utf-8`"" 
   $soapWebRequest.Accept      = "text/xml" 
   $soapWebRequest.Method      = "POST" 

   
   invoke-expression (DecryptString $docuSignSOAP)

   $requestStream = $soapWebRequest.GetRequestStream() 
   $SOAPRequest.Save($requestStream) 
   $requestStream.Close() 

   $resp = $soapWebRequest.GetResponse() 
   $responseStream = $resp.GetResponseStream() 
   $soapReader = [System.IO.StreamReader]($responseStream) 
   $ReturnXml = [Xml] $soapReader.ReadToEnd() 
   $responseStream.Close() 

   return $ReturnXml 
}

Function GetEncryptedPassword( [String] $docuSignUserName,
                               [String] $docuSignPassword,
                               [String] $docuSignURL )
{
   $soapAction = [String] "`"http://www.docusign.net/API/AccountManagement/GetEncryptedPassword`""
   $soap = [xml]@"
<?xml version=`"1.0`" encoding=`"utf-8`"?>
<soap:Envelope xmlns:xsi=`"http://www.w3.org/2001/XMLSchema-instance`" xmlns:xsd=`"http://www.w3.org/2001/XMLSchema`" xmlns:soap=`"http://schemas.xmlsoap.org/soap/envelope/`">
  <soap:Body>
    <GetEncryptedPassword xmlns=`"http://www.docusign.net/API/AccountManagement`" />
  </soap:Body>
</soap:Envelope>
"@
   
   $ret = Execute-SOAPRequest $docuSignUserName $docuSignPassword $soap $soapAction $docuSignURL
   if ($ret.Envelope.Body.GetEncryptedPasswordResponse.GetEncryptedPasswordResult.Success -eq "true")
   {
      $docuSignEncryptedPassword = $ret.Envelope.Body.GetEncryptedPasswordResponse.GetEncryptedPasswordResult.EncryptedPassword
   }
   else
   {
      $errorCode = $ret.Envelope.Body.GetEncryptedPasswordResponse.GetEncryptedPasswordResult.Error.ErrorCode
      $errorDescription = $ret.Envelope.Body.GetEncryptedPasswordResponse.GetEncryptedPasswordResult.Error.Description
      write-host @"
Error retrieving password for DocuSign account.
Error code:  $errorCode
Description: $errorDescription
"@
   }

   return $docuSignEncryptedPassword
}


Function AuthenticateMember( [String] $docuSignUserName,
                             [String] $docuSignPassword,
                             [String] $docuSignURL,
                             [REF]    $docuSignAccountId,
                             [REF]    $docuSignUserId )
{
   $soapAction = [String] "`"http://www.docusign.net/API/AccountManagement/AuthenticateMemberEx`""
   $soap = [xml] @"
<?xml version=`"1.0`" encoding=`"utf-8`"?>
<soap:Envelope xmlns:xsi=`"http://www.w3.org/2001/XMLSchema-instance`" xmlns:xsd=`"http://www.w3.org/2001/XMLSchema`" xmlns:soap=`"http://schemas.xmlsoap.org/soap/envelope/`">
  <soap:Body>
    <AuthenticateMemberEx xmlns=`"http://www.docusign.net/API/AccountManagement`">
      <AccountId></AccountId>
    </AuthenticateMemberEx>
  </soap:Body>
</soap:Envelope>
"@
   $ret = Execute-SOAPRequest $docuSignUserName $docuSignPassword $soap $soapAction $docuSignURL
   if ($ret.Envelope.Body.AuthenticateMemberExResponse.AuthenticateMemberExResult.Success -eq "true")
   {
       $docuSignAccountId.value = $ret.Envelope.Body.AuthenticateMemberExResponse.AuthenticateMemberExResult.AccountId
       $docuSignUserId.value    = $ret.Envelope.Body.AuthenticateMemberExResponse.AuthenticateMemberExResult.UserId
       return $true
   }
   else
   {
      $errorCode = $ret.Envelope.Body.AuthenticateMemberExResponse.AuthenticateMemberExResult.Error.ErrorCode
      $errorDescription = $ret.Envelope.Body.AuthenticateMemberExResponse.AuthenticateMemberExResult.Error.Description
      write-host @"
Error authenticating DocuSign account.
Error code:  $errorCode
Description: $errorDescription
"@
      return $false
   }
}


Function AttachAccount( [REF] $docuSignAccountId, 
                        [REF] $docuSignUserId, 
                        [REF] $docuSignLogin,
                        [REF] $docuSignEncryptedPassword,
                        [REF] $docuSignEnvironment )
{

   # Get the login and password for the account
   write-host "Please enter your DocuSign account credentials."

   $validCredentials = $false
   while ( $validCredentials -eq $false )
   {
      $docuSignEnvironment.value = PromptUserForDocuSignEnvironment

      $validEmail = $false
      while ( $validEmail -eq $false )
      {
         $docuSignLogin.value = Read-Host "DocuSign Login Email"
         if ( IsValidString $docuSignLogin.value "Email" $true 128 5 )
         {
            $validEmail = isValidEmail $docuSignLogin.value;
			if (!($validEmail))
			{
				write-host  "$docuSignLogin.value must be a valid email"
			}
         }
      }
      
      $validPassword = $false
      while ($validPassword -eq $false)
      {
         $docuSignPassword = Read-Host "Password" -AsSecureString
         $docuSignPassword = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($docuSignPassword))
         if ( IsValidString $docuSignPassword "Password" $true 32 6 )
         {
            $docuSignPassword = $docuSignPassword.Replace("&", "&amp;");
            $validPassword = $true
         }
      }
 
      $dsEnvValue   = $docuSignEnvironment.value
      $dsLoginValue = $docuSignLogin.value
      $confirmData  = read-host @"
Confirm
Is the following information correct?
   Environment:  $dsEnvValue
   Login:        $dsLoginValue
[Y] Yes  [N] No  [C] Cancel  (default is `"Y`")
"@

      if ( $confirmData.ToLower() -eq "c" )
      {
         return $false
      }
      elseif ( $confirmData.ToLower() -eq "n" )
      {
         $validCredentials = $false
      }
      else
      {
         $validCredentials = $true
      }
   }

   $docuSignURL = GetSiteName $docuSignEnvironment.value

   # Authenticate the user and get the account and user ids
   $memberAuthenticated = AuthenticateMember $docuSignLogin $docuSignPassword $docuSignURL $docuSignAccountId $docuSignUserId
   if ($memberAuthenticated -eq $true)
   {
      # Get the encrypted password
      $docuSignEncryptedPassword.value = GetEncryptedPassword $docuSignLogin $docuSignPassword $docuSignURL
      return $true
   }
   return $false
}


Function GetProvisioningInformation([String] $docuSignURL, 
                                    [String] $appToken,
                                    [REF]    $distributorCode,
                                    [REF]    $distributorPassword,
                                    [REF]    $pgp )
{
   $soapAction = [String] "`"http://www.docusign.net/API/AccountManagement/GetProvisioningInformation`""
   $soap = [xml] @"
<?xml version=`"1.0`" encoding=`"utf-8`"?>
<soap:Envelope xmlns:xsi=`"http://www.w3.org/2001/XMLSchema-instance`" xmlns:xsd=`"http://www.w3.org/2001/XMLSchema`" xmlns:soap=`"http://schemas.xmlsoap.org/soap/envelope/`">
  <soap:Body>
    <GetProvisioningInformation xmlns=`"http://www.docusign.net/API/AccountManagement`">
    <AppToken>$appToken</AppToken>
    </GetProvisioningInformation>
  </soap:Body>
</soap:Envelope>
"@

   $ret = Execute-SOAPRequest "" "" $soap $soapAction $docuSignURL
   if ($ret.Envelope.Body.GetProvisioningInformationResponse.GetProvisioningInformationResult.Success -eq "true")
   {
	   $distributorCode.value     = $ret.Envelope.Body.GetProvisioningInformationResponse.GetProvisioningInformationResult.DistributorCode
	   $distributorPassword.value = $ret.Envelope.Body.GetProvisioningInformationResponse.GetProvisioningInformationResult.DistributorPassword
	   $pgp.value                 = $ret.Envelope.Body.GetProvisioningInformationResponse.GetProvisioningInformationResult.Pgp
       return $true
   }
   else
   {
      $errorDescription = $ret.Envelope.Body.GetProvisioningInformationResponse.GetProvisioningInformationResult.Error.Description
      return $errorDescription
   }
}

Function NewAccount([String] $docuSignURL,
                    [String] $docuSignCompanyName, 
                    [String] $docuSignFirstName, 
                    [String] $docuSignLastName,
                    [String] $docuSignLogin,
                    [String] $docuSignPassword,
                    [String] $distributorCode,
                    [String] $distributorPassword,
                    [String] $pgp,
                    [REF]    $docuSignAccountId, 
                    [REF]    $docuSignUserId, 
                    [REF]    $docuSignEncryptedPassword )
{
   $soapAction = [String] "`"http://www.docusign.net/API/AccountManagement/NewAccount`""
   $soap = [xml] @"
<?xml version=`"1.0`" encoding=`"utf-8`"?>
<soap:Envelope xmlns:xsi=`"http://www.w3.org/2001/XMLSchema-instance`" xmlns:xsd=`"http://www.w3.org/2001/XMLSchema`" xmlns:soap=`"http://schemas.xmlsoap.org/soap/envelope/`">
  <soap:Body>
    <NewAccount xmlns=`"http://www.docusign.net/API/AccountManagement`">
      <AccountName>$docuSignCompanyName</AccountName>
      <DistributorCode>$distributorCode</DistributorCode>
      <DistributorPassword>$distributorPassword</DistributorPassword>
      <Pgp>$pgp</Pgp>
      <CreditCardInformation></CreditCardInformation>
      <ReferralInformation>
        <ReferrerName>MSSharePoint</ReferrerName>
        <PromoCode>MSSharePoint</PromoCode>
      </ReferralInformation>
      <AccountSettings></AccountSettings>
      <Member>
        <MemberEmailAddress>$docuSignLogin</MemberEmailAddress>
        <MemberUserName>$docuSignFirstName $docuSignLastName</MemberUserName>
        <MemberPassword>$docuSignPassword</MemberPassword>
        <MemberFirstName>$docuSignFirstName</MemberFirstName>
        <MemberLastName>$docuSignLastName</MemberLastName>
        <MemberSettings>
          <CanManageAccount>true</CanManageAccount>
          <CanSendEnvelope>true</CanSendEnvelope>
          <APIAccountWideAccess>true</APIAccountWideAccess>
          <AllowSendOnBehalfOf>true</AllowSendOnBehalfOf>
        </MemberSettings>
        <ReturnEncryptedPassword>true</ReturnEncryptedPassword>
      </Member>
      <AddressInformation></AddressInformation>
    </NewAccount>
  </soap:Body>
</soap:Envelope>
"@
   
   $ret = Execute-SOAPRequest $docuSignLogin $docuSignPassword $soap $soapAction $docuSignURL
   if ($ret.Envelope.Body.NewAccountResponse.NewAccountResult.Success -eq "true")
   {
       $docuSignAccountId.value         = $ret.Envelope.Body.NewAccountResponse.NewAccountResult.AccountId
       $docuSignUserId.value            = $ret.Envelope.Body.NewAccountResponse.NewAccountResult.UserId
       $docuSignEncryptedPassword.value = $ret.Envelope.Body.NewAccountResponse.NewAccountResult.EncryptedPassword
       return $true
   }
   else
   {
      $errorDescription = $ret.Envelope.Body.NewAccountResponse.NewAccountResult.Error.Description
      return $errorDescription
   }
}

Function CreateDocuSignConfiguration( $list, 
                                      [String] $docuSignAccountId, 
                                      [String] $docuSignUserId,
                                      [String] $docuSignLogin,
                                      [String] $docuSignEncryptedPassword,
                                      [String] $docuSignEnvironment )
{
   if($list -ne $null )
   {
      $newItem = $list.items.Add()
      $newItem["Title"]                      = "DocuSign Account"
      $newItem["Account ID"]                 = $docuSignAccountId
      $newItem["User ID"]                    = $docuSignUserId
      $newItem["DocuSign Login"]             = $docuSignLogin
      $newItem["Password"]                   = $docuSignEncryptedPassword
      $newItem["Environment"]                = $docuSignEnvironment
      $newItem["Envelope Warning Threshold"] = 25
      $newItem["Envelope Check Enabled"]     = "true"
      $newItem["EMail Subject"]              = "Please DocuSign [FileName]"
      $newItem["EMail Body"]                 = @"
SENT TO YOU BY: [UserName] [Email] with the DocuSign Electronic Signature Service.
I am sending you this request for your electronic signature, please review and electronically sign by following the link below.

Thank You,
[UserName] [Email]
"@
      
      $newItem.update() 
   }
}


Function CreateDocuSignConfigurationForSite( [String] $url, 
                                             [String] $docuSignAccountId, 
                                             [String] $docuSignUserId,
                                             [String] $docuSignLogin,
                                             [String] $docuSignEncryptedPassword,
                                             [String] $docuSignEnvironment)
{
   $web = Get-SPWeb $url
   
   #Check If the Web is null
   if ($web -ne $null)
   {
      #Get the DocuSign account configuration list in this site
      $list = $web.Lists[$dsAccountConfigListName]
       if($list -ne $null )
      {
         $itemCount = $list.ItemCount
         if ($itemCount -gt 0)
         {
            # There should be only one account configuration object.
            # Delete all account configuration objects except for the first.
            while ($itemCount -gt 1)
            {
               $list.items.delete(1)
               $itemCount--
            }
            $list.update()

            $acctConfigItem = $list.items[0]
            $currentAccountId = $acctConfigItem['Account ID']
            $currentUserId    = $acctConfigItem['User ID'] 
            $currentEnv       = $acctConfigItem['Environment']
            
            if ( $currentAccountId -eq $docuSignAccountId   -and 
                 $currentUserId    -eq $docuSignUserId      -and
                 $currentEnv       -eq $docuSignEnvironment      )
            {
               # The site is already configured with the account and user ids.
               # Update the password if it is different and then return because 
               # we do not have to create new configuration objects or delete 
               # the existing user records
               $currentPassword = $acctConfigItem["Password"]
               if ($currentPassword -ne $docuSignEncryptedPassword)
               {
                  $acctConfigItem["Password"] = $docuSignEncryptedPassword
                  $acctConfigItem.update()
               }
               return
            }
         }
 
         # delete all existing account configurations
         while ($itemCount -gt 0)
         {
            $list.items.delete(0)
            $itemCount--
         }
         $list.update()
         
         # Delete all user records
         $userList = $web.Lists[$dsUserConfigListName]
         if ($userList -ne $null )
         {
            $itemCount = $userList.ItemCount
            while ($itemCount -gt 0)
            {
               $userList.items.delete(0)
               $itemCount--
            }
            $userList.update()
         }

         #add the new DocuSign Account configuration information
         CreateDocuSignConfiguration $list $docuSignAccountId $docuSignUserId $docuSignLogin $docuSignEncryptedPassword $docuSignEnvironment
      }

      #Dispose of the web object
      $web.Dispose()
   }
   else
   {
      echo "    Web is null. Check the Web URL."
   }
}


Function UpdateAccountConfiguration( [String] $regEx)
{
   $configureAccount = Read-Host @"
You must specify DocuSign account credentials prior to sending envelopes.

If you specify the account credentials now, all sites that have the DocuSign feature activated will be updated with the credentials.

If your environment requires the DocuSign feature to use a Proxy Server, configure the DocuSign account in SharePoint after updating the settings. (See the included documentation for details.)

Do you want to configure a DocuSign account using an [E] existing account, [N] new DocuSign account, or [S] skip DocuSign configuration?  Default[E]
"@

   if ($configureAccount.ToLower() -eq "s") {
      # Do nothing, the user opted to skip account configuration
   }
   else {
      if ( $regEx.length -eq 0) {
         $regEx = Read-Host "Enter a PowerShell regular expression matching string to select the site URLs to configure (default is all sites)"
         
         if ($regEx -eq "") {
            $regEx = "\w"
         }
         else {
            write-host "Sites to be updated: "
            Get-SPSite | ForEach-Object {
               if ( [RegEx]::IsMatch($_.Url, $regEx) ) {
                  $url = $_.Url
                  write-host "   $url"
               }
            }
            $continue = Read-Host "Continue [C] or exit [E]?  Default [C]"
            if ($continue.ToLower() -eq "e") {
               return
            }
         }
      }

      $docuSignAccountId         = ""
      $docuSignUserId            = ""
      $docuSignLogin             = ""
      $docuSignEncryptedPassword = ""
      $docuSignEnvironment       = ""
      $haveAccountCredentials    = $false
      if ($configureAccount.ToLower() -eq "n") {
         $haveAccountCredentials = CreateNewAccount ([REF] $docuSignAccountId) ([REF] $docuSignUserId) ([REF] $docuSignLogin) ([REF] $docuSignEncryptedPassword) ([REF] $docuSignEnvironment)
      }
      else {
         $haveAccountCredentials = AttachAccount ([REF] $docuSignAccountId) ([REF] $docuSignUserId) ([REF] $docuSignLogin) ([REF] $docuSignEncryptedPassword) ([REF] $docuSignEnvironment)
      }

      if ( $haveAccountCredentials -eq $true -and
           $docuSignAccountId.length -gt 0 -and
           $docuSignUserId.length -gt 0 -and
           $docuSignEncryptedPassword.length -gt 0 ) {
         Get-SPSite | ForEach-Object {
            if ( [RegEx]::IsMatch($_.Url, $regEx) ) {
               $feature = Get-SPFeature -Identity $solutionId -Site $_.Url -EA 0;
               if ( $feature ) {
                  write-host "$_ "
                  CreateDocuSignConfigurationForSite $_.Url $docuSignAccountId $docuSignUserId $docuSignLogin $docuSignEncryptedPassword $docuSignEnvironment
               }
               else {
                  write-host "$_  - DocuSign is not configured for this site. Skipping configuration"
               }
            }
         }
      }
   }
}


Function DisplayDocuSignConfigurationForSite([String] $url)
{
   $web = Get-SPWeb $url
   
   #Check If the Web is null
   if ($web -ne $null)
   {
      $obj = New-Object PSObject
      $obj | Add-Member NoteProperty Site($url)
      
      #Get the list in this site
      $list = $web.Lists[$dsAccountConfigListName]
 
      if($list -ne $null )
      {
         if ($list.ItemCount -gt 0)
         {
             $item = $list.Items[0];
             $obj | Add-Member NoteProperty Status("DocuSign Configured")
             $obj | Add-Member NoteProperty DocuSignLogin($item["DocuSign Login"])
             $obj | Add-Member NoteProperty Environment($item["Environment"])
             $obj | Add-Member NoteProperty AccountID($item["Account ID"])
             $obj | Add-Member NoteProperty UserID($item["User ID"])
         }
         else
         {
             $obj | Add-Member NoteProperty Status("DocuSign Activated" )
         }
      }
      else
      {
         $obj | Add-Member NoteProperty Status("DocuSign Not Configured Correctly" )
      }
      Write-Output $obj
      #Dispose of the web object
      $web.Dispose()
   }
   else
   {
      echo "    Web is null. Check the Web URL."
   }
}

Function DisplayDocuSignConfiguration
{
   ## SharePoint DLL Reference
   [void][System.Reflection.Assembly]::LoadWithPartialName("Microsoft.SharePoint")
   [void][System.Reflection.Assembly]::LoadWithPartialName("Microsoft.SharePoint.Administration")


   if ( ! ( get-spsolution -Identity $solutionGuid ) )
   {
       write-host "The DocuSign feature is not installed."
       return
   }

   Get-SPSite | ForEach-Object { 
      $feature = Get-SPFeature -Identity $solutionId -Site $_.Url -EA 0;
      if ( $feature ) {
         DisplayDocuSignConfigurationForSite($_.Url)
      }
      else {
         $obj = New-Object PSObject
         $obj | Add-Member NoteProperty Site($_.Url)
         $obj | Add-Member NoteProperty Status("DocuSign Feature not activated")
         Write-Output $obj
      }
   }
}


Function VerifyArguments
{
   if ( $action -ne "install" -and $action -ne "update" -and $action -ne "uninstall" -and $action -ne "displayconfig" -and $action -ne "updateconfig") {
      "Error:  you must specify a valid action."
      " "
      $usageInfo
      exit 1
   }


   if ( $action -eq "install" -or $action -eq "update" ) {
      if ( $activate -eq "" ) {
         "Error:  when installing or updating you must specify if the feature should be activated in all sites."
         " "
         $usageInfo
         exit 1
      }
   }
}


Function InstallVeriSignCert
{
   # verify that the user is willing to install the required certificate
   $cert = Get-PfxCertificate $currentDirectory\VeriSignClass3PublicPrimaryCertificationAuthority-G5.crt
   $installedCert = get-sptrustedrootauthority | where {$_.certificate.serialnumber -eq $cert.serialnumber}

   if (! $installedCert ) {
      $installCerts = Read-Host @"
The DocuSign feature requires a VeriSign certificate to be specified as a trusted root authority in order to communicate with the DocuSign service.
This script will install the certificate as a trusted root authority.
Do you want to continue and install the certificate [C] or exit and stop the installation [E]?  Default[E]
"@

      if ($installCerts -ne "C") {
         return $false
      }

      # Install VeriSign certificate
      $cert = Get-PfxCertificate $currentDirectory\VeriSignClass3PublicPrimaryCertificationAuthority-G5.crt
      $installedCert = get-sptrustedrootauthority | where {$_.certificate.serialnumber -eq $cert.serialnumber}
      if (! $installedCert ) {
         New-SPTrustedRootAuthority -Name "VeriSignClass3PublicPrimaryCertificationAuthority-G5" -Certificate $cert
      }

   }
   
   return $true
}


Function StartAdminService()
{
   $SPAdminServiceStarted = $false

   # Verify the SharePoint administration service is installed.
   $SPAdminService = get-service -displayname $SPAdminServiceName -ErrorAction SilentlyContinue
   if (! $SPAdminService) {
      "Error:  could not find the " + $SPAdminServiceName + " service.  The DocuSign feature will not be installed"
      exit 1
   }

   # Start the SharePoint Administration service if it is not already running
   if ($SPAdminService.status -eq "stopped") {
      $SPAdminServiceStarted = $true
      Start-Service -displayname $SPAdminServiceName
   }

   # Wait for the service to start
   $retryCount = 0
   $SPAdminService = get-service -displayname $SPAdminServiceName -ErrorAction SilentlyContinue
   while ($SPAdminService.status -ne "running" -and $retryCount -lt $maxRetries) {
      Start-sleep -s 1
      $retryCount++
      $SPAdminService = get-service -displayname $SPAdminServiceName -ErrorAction SilentlyContinue
   }

   if ($SPAdminService.status -ne "running" -and $retryCount -ge $maxRetries) {
      "Error:  timed out waiting for " + $SPAdminServiceName + " service to start.  The DocuSign feature will not be installed"
      exit 1
   }
   
   return $SPAdminServiceStarted
}


Function Install
{
   if ( ! (InstallVeriSignCert) )
   {
      return
   }

   # Add and install the DocuSign feature solution
   if ( ! (add-spsolution -LiteralPath $currentDirectory\$solutionName) ) {
      return
   }

   install-spsolution -Identity $solutionGuid -GACDeployment

   # Wait until the solution has been deployed before stopping the server.
   $retryCount = 0
   do { 
      start-sleep 2 
      $retryCount++
   } while ( !( (get-spsolution -Identity $solutionGuid).deployed) -and $retryCount -lt $maxRetries)

   if ( $retryCount -ge $maxRetries) {
      write-host "The installation timed out while waiting for the DocuSign solution to be installed."
      return
   }

   # If requested, activate the feature on all sites
   if ( $activate -ne $false ) {
      Get-SPSite | ForEach-Object { 
         $feature = Get-SPFeature -Identity $solutionId -Site $_.Url -EA 0;
         if ( ! $feature ) { 
            Enable-SPFeature -Identity $solutionId -url:$_.Url;
			addDocuSignConnector $_.Url;
         }
      }

      UpdateAccountConfiguration
   }
}


Function Update ()
{
   if ( !( (get-spsolution -Identity $solutionGuid).deployed ) ) {
      "Error:  The DocuSign solution must be installed in order to update"
      return
   }
   
   Update-SPSolution -Identity $solutionGuid -LiteralPath $currentDirectory\$solutionName -GACDeployment

   # Wait until the solution has been deployed before stopping the server.
   $retryCount = 0
   do { 
      start-sleep 2 
      
      # Use stsadm -o enumdeployments to get the outstanding depoloyments.  The command returns an array of strings
      # Search for "<File>docusign.wsp" to see if there is a pending docusign deployment
      # If the string is not found then the doployment is complete
      $stillUpdating = $false
      stsadm -o enumdeployments | foreach-object{ if ($_.Contains("<File>docusign") -and $_.Contains(".wsp</File>")) { $stillUpdating = $true } }
      $retryCount++
   } while ( $stillUpdating -and $retryCount -lt $maxRetries)

   if ( $activate -ne $false ) {
      # activate the feature on all sites
      Get-SPSite | ForEach-Object { 
         $feature = Get-SPFeature -Identity $solutionId -Site $_.Url -EA 0;
         if ( ! $feature ) { 
            Enable-SPFeature -Identity $solutionId -url:$_.Url;
			addDocuSignConnector $_.Url;
         }
      }

      UpdateAccountConfiguration
   }
}


Function Uninstall ()
{
   # uninstall the solution
   $solution = get-spsolution -Identity $solutionGuid
   if ( $solution ) {
      $uninstall = Read-Host @"
Confirm
Are you sure you want to deactivate, uninstall and remove the DocuSign feature from all sites?
[Y] Yes  [N] No  (default is `"Y`")
"@

      if ( $uninstall.ToLower() -eq "n" ) {
         return
      }

      # deactivate the solution in all sites
      Get-SPSite | ForEach-Object { 
         $feature = Get-SPFeature -Identity $solutionId -Site $_.Url -EA 0;
         if ( $feature ) {
			deleteDocuSignConnector $_.Url;
            Disable-SPFeature -Identity $solutionId -confirm:$false -url:$_.Url;
         }
      }

      if ( $solution.deployed ) {
         uninstall-spsolution -Identity $solutionGuid -confirm:$false 

         # Wait for the solution to be uninstalled
         $retryCount = 0
         do { 
            start-sleep 2 
            $retryCount++
         } while ( ( (get-spsolution -Identity $solutionGuid).deployed) -and $retryCount -lt $maxRetries)
      }

      start-sleep 2

      ## remove the solution
      if ( !(remove-spsolution -Identity $solutionGuid -confirm:$false -Force ) )
      {
         return
      }
   }

}


Function IsValidString ( [String] $strToVerify, [String] $strName, [bool] $required, [int] $maxChars, [int] $minChars )
{
   if ( $required -and $strToVerify.length -eq 0 )
   {
      write-host "You must enter a $strName"
      return $false
   }

   if ($minChars -gt 0 -and $strToVerify.length -lt $minChars) 
   {
        write-host  "$strName must be $minChars characters or more and is too short with $strToVerify.length characters"
        return $false;
    }	

   if ( $maxChars -gt 0 -and $strToVerify.length -gt $maxChars )
   {
      write-host "$strName can contain at most $maxChars characters.  Please re-enter $strName"
      return $false
   }

   if ( $strToVerify -match "<" -or
        $strToVerify -match ">"     )
   {
      write-host "$strName cannot contain the characters `"<`" or `">`""
      return $false
   }

   return $true
}


Function PromptUserForDocuSignEnvironment ( )
{
   $docuSignEnvironment = Read-Host @"
In which DocuSign environment do you want to configure the account?
[P] Production  [D] Demo  [V] Preview  (default is "P")
"@

   $docuSignEnvironment = $docuSignEnvironment.ToLower()
   if ( $docuSignEnvironment -eq "v" )
   {
      $docuSignEnvironment = "preview" 
   }
   elseif ( $docuSignEnvironment -eq "d" )
   {
      $docuSignEnvironment = "demo" 
   }
   elseif ( $docuSignEnvironment -eq "test" )
   {
      $docuSignEnvironment = "test"
   }
   else
   {
      $docuSignEnvironment = "production"
   }

   return $docuSignEnvironment
}


Function PromptForNewAccount( [REF] $docuSignEnvironment, 
                              [REF] $docuSignCompanyName, 
                              [REF] $docuSignFirstName,
                              [REF] $docuSignLastName,
                              [REF] $docuSignEmail,
                              [REF] $docuSignPassword  )
{

   write-host "Please enter the information about your new DocuSign account."
   
   $validCredentials = $false
   while ( $validCredentials -eq $false )
   {
      $docuSignEnvironment.value = PromptUserForDocuSignEnvironment

      $validCompanyName = $false
      while ( $validCompanyName -eq $false )
      {
         $docuSignCompanyName.value = Read-Host "Company Name"
         if ( IsValidString $docuSignCompanyName.value "Company Name" $false 100 2)
         {
            $validCompanyName = $true
         }
      }
      
      $validFirstName = $false
      while ( $validFirstName -eq $false )
      {
         $docuSignFirstName.value = Read-Host "First Name"
         if ( IsValidString $docuSignFirstName.value "First Name" $true 50 3 )
         {
            $validFirstName = $true
         }
      }

      $validLastName = $false
      while ( $validLastName -eq $false )
      {
         $docuSignLastName.value = Read-Host "Last Name"
         if ( IsValidString $docuSignLastName.value "Last Name" $true 50 3)
         {
            $validLastName = $true
         }
      }

      $validEmail = $false
      while ( $validEmail -eq $false )
      {
         $docuSignEmail.value = Read-Host "Email"
         if ( IsValidString $docuSignEmail.value "Email" $true 128 5)
         {
            $validEmail = isValidEmail $docuSignEmail.value;
			if (!($validEmail))
			{
			write-host  "$docuSignEmail.value must be a valid email"
			}
         }
      }
      
      $validPassword = $false
      while ($validPassword -eq $false)
      {
         $validPassword1 = $false
         while ( $validPassword1 -eq $false)
         {
            $docuSignPassword1 = Read-Host "Password" -AsSecureString
            $docuSignPassword1 = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($docuSignPassword1))
            if ( IsValidString $docuSignPassword1 "Password" $true 32 6)
            {
               $validPassword1 = $true
            }
         }

         $validPassword2 = $false
         while ( $validPassword2 -eq $false)
         {
            $docuSignPassword2 = Read-Host "Reenter Password" -AsSecureString
            $docuSignPassword2 = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($docuSignPassword2))

            if ( IsValidString $docuSignPassword2 "confirming password" $true 32 6)
            {
               $validPassword2 = $true
            }
         }

         if ( $docuSignPassword1 -ne $docuSignPassword2 )
         {
            write-host "The passwords do not match.  Please re-enter the passwords."
         }
         else
         {
            $docuSignPassword.value = $docuSignPassword1.Replace("&", "&amp;");
            $validPassword = $true
         }
      }
 
      $dsEnvValue         = $docuSignEnvironment.value
      $dsEmailValue       = $docuSignEmail.value
      $dsCompanyNameValue = $docuSignCompanyName.value
      $dsFirstNameValue   = $docuSignFirstName.value
      $dsLastNameValue    = $docuSignLastName.value

      $confirmData = read-host @"
Confirm
Is the following information correct?
   Environment:    $dsEnvValue
   Login:          $dsEmailValue
   First Name:     $dsFirstNameValue
   Last Name:      $dsLastNameValue
   Company Name:   $dsCompanyNameValue
[Y] Yes  [N] No  [C] Cancel  (default is `"Y`")
"@

      if ( $confirmData.ToLower() -eq "c" )
      {
         return $false
      }
      elseif ( $confirmData.ToLower() -eq "n" )
      {
         $validCredentials = $false
      }
      else
      {
         $validCredentials = $true
      }
   }
   
   $docuSignAgreeToConditions = Read-Host @"
Confirm
Do you agree to the DocuSign Terms and Conditions at http://www.docusign.com/terms_and_conditions.php?
[Y] Yes  [N] No (default is "N")
"@

   if ( $docuSignAgreeToConditions.ToLower() -ne "y" )
   {
      return $false
   }

   return $true
}


Function CreateNewAccount( [REF] $docuSignAccountId, 
                           [REF] $docuSignUserId,
                           [REF] $docuSignEmail,
                           [REF] $docuSignEncryptedPassword,
                           [REF] $docuSignEnvironment )
{
   $docuSignCompanyName = ""
   $docuSignFirstName   = ""
   $docuSignLastName    = ""
   $docuSignPassword    = ""

   $promptResult = PromptForNewAccount $docuSignEnvironment ([REF] $docuSignCompanyName) ([REF] $docuSignFirstName) ([REF] $docuSignLastName) $docuSignEmail ([REF] $docuSignPassword)

   if ( $promptResult -eq $false )
   {
      return $false
   }

   $docuSignURL         = GetSiteName $docuSignEnvironment.value
   $distributorCode     = ""
   $distributorPassword = ""
   $pgp = ""

   $provInfo = GetProvisioningInformation $docuSignURL "SHAREPOINT_CRM_SOBO" ([REF] $distributorCode) ([REF] $distributorPassword) ([REF] $pgp)
   if ( $provInfo -ne $true)
   {
      $provInfo = GetProvisioningInformation $docuSignURL "CRM_SOBO" ([REF] $distributorCode) ([REF] $distributorPassword) ([REF] $pgp)
      if ( $provInfo -ne $true)
      {
         write-host @"
DocuSign reported an error when getting the provision information for the account.
Error: $provInfo
"@
         return $false
      }
   }

   $newAcctResult = NewAccount $docuSignURL $docuSignCompanyName $docuSignFirstName $docuSignLastName $docuSignEmail $docuSignPassword $distributorCode $distributorPassword $pgp $docuSignAccountId $docuSignUserId $docuSignEncryptedPassword
   if ( $newAcctResult -eq $true )
   {
      if ($docuSignEncryptedPassword.value.length -eq 0)
      {
         # in the case that the email and passwords are the same, but the user name changes, our
         # API for NewAccount doesn't return the encrypted password. Compensate
         $docuSignEncryptedPassword.value = GetEncryptedPassword $docuSignEmail $docuSignPassword $docuSignURL
      }
   }
   else
   {
      write-host @"
DocuSign reported an error when provisioning the account.
Error: $newAcctResult
"@

      return $false
   }
   
   return $true
}

Function addDocuSignConnector([String] $url)
{

	$site = Get-SPSite -Identity $url
	#Add-Type -AssemblyName ("DocuSign, Version=1.2.0.0, Culture=neutral, PublicKeyToken=678e2d3771d1e85a")
	#Add-Type -path  $(get-location)+'DocuSignSharePointIntegration.dll'

	foreach($web in $site.AllWebs)
	{
		foreach($list in $web.Lists)
		{
			if($list.BaseType -eq 1 -and $list.Hidden -eq $false)
			{
				$folder = $list.RootFolder;
				$folder.Properties["DocSign_Enabled"] = "1";
				$folder.Update();

                $spua = $list.UserCustomActions.Add()
                $spua.Title = 'DocuSign'
                $spua.Description = 'DocuSign'
                $spua.Location = 'CommandUI.Ribbon.ListView'
                $spua.Sequence = 0
                $spua.CommandUIExtension = $docuSign_DS_RIBBON_BUTTON_CREATION_COMMAND
                $spua.Update();

                $spuaSend = $list.UserCustomActions.Add()
                $spuaSend.Title = 'Send With DocuSign'
                $spuaSend.Description = 'Send With DocuSign'
                $spuaSend.ImageUrl = '/_layouts/images/DocuSignFeatureReceiver/DSIcon16x16.gif'
                $spuaSend.Location = 'EditControlBlock'
                $spuaSend.Sequence = 300
                $spuaSend.Url = '/_layouts/DocuSignSharePointIntegration/DocuSignSend.aspx?userRequest=SendWithDocuSign&ItemId={ItemId}&ListId={ListId}&ItemURL={ItemUrl}&onFinishURL={Source}'
                $spuaSend.Update();

                $spuaSign = $list.UserCustomActions.Add()
                $spuaSign.Title = 'Sign With DocuSign'
                $spuaSign.Description = 'Sign With DocuSign'
                $spuaSign.ImageUrl = '/_layouts/images/DocuSignFeatureReceiver/DSIcon16x16.gif'
                $spuaSign.Location = 'EditControlBlock'
                $spuaSign.Sequence = 310
                $spuaSign.Url = '/_layouts/DocuSignSharePointIntegration/DocuSignSend.aspx?userRequest=SignWithDocuSign&ItemId={ItemId}&ListId={ListId}&ItemURL={ItemUrl}&onFinishURL={Source}'
                $spuaSign.Update();


			}
		}
		$web.Dispose();
	}

	$site.Dispose();

}

Function deleteDocuSignConnector([String] $url)
{
	$site = Get-SPSite -Identity $url
	#Add-Type -AssemblyName  ("DocuSign, Version=1.2.0.0, Culture=neutral, PublicKeyToken=678e2d3771d1e85a")
	#Add-Type -path  $(get-location)+'DocuSignSharePointIntegration.dll'

	foreach($web in $site.AllWebs)
	{
		foreach($list in $web.Lists)
		{
			if($list.BaseType -eq 1 -and $list.Hidden -eq $false)
			{
				$folder = $list.RootFolder;
				$folder.Properties["DocSign_Enabled"] = "0";
				$folder.Update();

				$ids = New-Object System.Collections.ObjectModel.Collection[System.Guid]
				foreach($spua in $list.UserCustomActions)
				{
					if($spua.Title -eq 'DocuSign')
					{
						$ids.Add($spua.Id)
					}

                    if ($spua.Title -eq 'Send With DocuSign')
					{
                        $ids.Add($spua.Id)
					}

                    if ($spua.Title -eq 'Sign With DocuSign')
					{
                        $ids.Add($spua.Id)
					}
				}

				foreach($guid in $ids)
				{
					$list.UserCustomActions[$guid].Delete()
				}
			}
		}
		$web.Dispose();
	}

	$site.Dispose();

}



function isValidEmail{
    param([string]$address)
    ($address -as [System.Net.Mail.MailAddress]).Address `
        -eq $address -and $address -ne $null
}

#
# Main body of the script
#
$action = $action.ToLower()
VerifyArguments

$SPAdminServiceStarted = $false

if ( $action -eq "install") {
   # Start the SharePoint Administration service if it is not already running
   $SPAdminServiceStarted = StartAdminService

   Install
}
elseif ( $action -eq "update") {
   # Start the SharePoint Administration service if it is not already running
   $SPAdminServiceStarted = StartAdminService

   Update
}
elseif ( $action -eq "uninstall") {
   # Start the SharePoint Administration service if it is not already running
   $SPAdminServiceStarted = StartAdminService

   Uninstall
}
elseif ( $action -eq "updateconfig") {
   UpdateAccountConfiguration
}
elseif ( $action -eq "displayconfig") {
   DisplayDocuSignConfiguration
}

# If this script started the admin service then stop it now.
if ( $SPAdminServiceStarted -eq $true) {
   stop-service $SPAdminServiceName
}


# SIG # Begin signature block
# MIIOjAYJKoZIhvcNAQcCoIIOfTCCDnkCAQExCzAJBgUrDgMCGgUAMGkGCisGAQQB
# gjcCAQSgWzBZMDQGCisGAQQBgjcCAR4wJgIDAQAABBAfzDtgWUsITrck0sYpfvNR
# AgEAAgEAAgEAAgEAAgEAMCEwCQYFKw4DAhoFAAQUCOKsjqqHMikyY2DauF6VzFOB
# xk+ggguLMIIFeTCCBGGgAwIBAgIQD+Od+p6x2u+a3QRsJllmijANBgkqhkiG9w0B
# AQUFADCBtDELMAkGA1UEBhMCVVMxFzAVBgNVBAoTDlZlcmlTaWduLCBJbmMuMR8w
# HQYDVQQLExZWZXJpU2lnbiBUcnVzdCBOZXR3b3JrMTswOQYDVQQLEzJUZXJtcyBv
# ZiB1c2UgYXQgaHR0cHM6Ly93d3cudmVyaXNpZ24uY29tL3JwYSAoYykxMDEuMCwG
# A1UEAxMlVmVyaVNpZ24gQ2xhc3MgMyBDb2RlIFNpZ25pbmcgMjAxMCBDQTAeFw0x
# MjA5MDcwMDAwMDBaFw0xNTA5MjgyMzU5NTlaMIG8MQswCQYDVQQGEwJVUzETMBEG
# A1UECBMKV2FzaGluZ3RvbjEQMA4GA1UEBxMHU2VhdHRsZTEXMBUGA1UEChQORG9j
# dVNpZ24sIEluYy4xPjA8BgNVBAsTNURpZ2l0YWwgSUQgQ2xhc3MgMyAtIE1pY3Jv
# c29mdCBTb2Z0d2FyZSBWYWxpZGF0aW9uIHYyMRQwEgYDVQQLFAtFbmdpbmVlcmlu
# ZzEXMBUGA1UEAxQORG9jdVNpZ24sIEluYy4wggEiMA0GCSqGSIb3DQEBAQUAA4IB
# DwAwggEKAoIBAQChu6ySUOxMi07zu4w6dcd39EU7L+U7HT/aWhAOQlZaSImF6FS5
# MB6AUEzl/67ug4TYlcLp3hXqoaaVIgxfE5JBXcz8yCPp6i7GCmBB+foJCiDdcMn5
# qUS4M4bMm0bwFN2tcz5ZS3niHuYQ4nX67g9ewuetfc70YB2xpirdddjBBHEFcbi0
# vVNOaLzUfY9HZGoCHqMU2KAPWVsXFie8xWWejP7uQXmnAqL0eLnS2YSheFTs5h5d
# LUOYF+79kRb03zR6ZBIbKYSRzL+RPWv2EJi9rCzZ+IDmdEB4EKKCZBu/lgATh2uo
# qwZWGbAuiLHzBOsV9yp+RrisCDthuJsnj93ZAgMBAAGjggF7MIIBdzAJBgNVHRME
# AjAAMA4GA1UdDwEB/wQEAwIHgDBABgNVHR8EOTA3MDWgM6Axhi9odHRwOi8vY3Nj
# My0yMDEwLWNybC52ZXJpc2lnbi5jb20vQ1NDMy0yMDEwLmNybDBEBgNVHSAEPTA7
# MDkGC2CGSAGG+EUBBxcDMCowKAYIKwYBBQUHAgEWHGh0dHBzOi8vd3d3LnZlcmlz
# aWduLmNvbS9ycGEwEwYDVR0lBAwwCgYIKwYBBQUHAwMwcQYIKwYBBQUHAQEEZTBj
# MCQGCCsGAQUFBzABhhhodHRwOi8vb2NzcC52ZXJpc2lnbi5jb20wOwYIKwYBBQUH
# MAKGL2h0dHA6Ly9jc2MzLTIwMTAtYWlhLnZlcmlzaWduLmNvbS9DU0MzLTIwMTAu
# Y2VyMB8GA1UdIwQYMBaAFM+Zqep7JvRLyY6P1/AFJu/j0qedMBEGCWCGSAGG+EIB
# AQQEAwIEEDAWBgorBgEEAYI3AgEbBAgwBgEBAAEB/zANBgkqhkiG9w0BAQUFAAOC
# AQEAHD8TRISHSWtbJcSzftUlG4ST59+1twHBSGj2lBmhJ1be+Qk9vTw3abx+27Wc
# 3Ysx4tDLvI2Lf6AyBQPhDIxhfILK5RPcK3sMIp+AeGkmcx1guJpziApGY1rtMLer
# 7WMW+mTZLfAVUebnSNvNHBcdgsseRpgRC41VbuDVZ+9mJkS3PRCVOvudXgtgMnSr
# bB/4bvRr0OzVl/lcZbBNqudyoNnqV8G6gk22qvV4YTDxFV76DfPPmaZLysIYGm1m
# waThP7ZmqVSZYmpfkDQ3rAxwl1Z+2sJyaMRd/xZvqxo19YQ+8HwRdG3Nqvjt3Aar
# QVsI3LioK7msDAGO5orXPw7tIzCCBgowggTyoAMCAQICEFIA5aolVvwahu2WydRL
# M8cwDQYJKoZIhvcNAQEFBQAwgcoxCzAJBgNVBAYTAlVTMRcwFQYDVQQKEw5WZXJp
# U2lnbiwgSW5jLjEfMB0GA1UECxMWVmVyaVNpZ24gVHJ1c3QgTmV0d29yazE6MDgG
# A1UECxMxKGMpIDIwMDYgVmVyaVNpZ24sIEluYy4gLSBGb3IgYXV0aG9yaXplZCB1
# c2Ugb25seTFFMEMGA1UEAxM8VmVyaVNpZ24gQ2xhc3MgMyBQdWJsaWMgUHJpbWFy
# eSBDZXJ0aWZpY2F0aW9uIEF1dGhvcml0eSAtIEc1MB4XDTEwMDIwODAwMDAwMFoX
# DTIwMDIwNzIzNTk1OVowgbQxCzAJBgNVBAYTAlVTMRcwFQYDVQQKEw5WZXJpU2ln
# biwgSW5jLjEfMB0GA1UECxMWVmVyaVNpZ24gVHJ1c3QgTmV0d29yazE7MDkGA1UE
# CxMyVGVybXMgb2YgdXNlIGF0IGh0dHBzOi8vd3d3LnZlcmlzaWduLmNvbS9ycGEg
# KGMpMTAxLjAsBgNVBAMTJVZlcmlTaWduIENsYXNzIDMgQ29kZSBTaWduaW5nIDIw
# MTAgQ0EwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQD1I0tepdeKuzLp
# 1Ff37+THJn6tGZj+qJ19lPY2axDXdYEwfwRof8srdR7NHQiM32mUpzejnHuA4Jnh
# 7jdNX847FO6G1ND1JzW8JQs4p4xjnRejCKWrsPvNamKCTNUh2hvZ8eOEO4oqT4Vb
# kAFPyad2EH8nA3y+rn59wd35BbwbSJxp58CkPDxBAD7fluXF5JRx1lUBxwAmSkA8
# taEmqQynbYCOkCV7z78/HOsvlvrlh3fGtVayejtUMFMb32I0/x7R9FqTKIXlTBdO
# flv9pJOZf9/N76R17+8V9kfn+Bly2C40Gqa0p0x+vbtPDD1X8TDWpjaO1oB21xku
# pc1+NC2JAgMBAAGjggH+MIIB+jASBgNVHRMBAf8ECDAGAQH/AgEAMHAGA1UdIARp
# MGcwZQYLYIZIAYb4RQEHFwMwVjAoBggrBgEFBQcCARYcaHR0cHM6Ly93d3cudmVy
# aXNpZ24uY29tL2NwczAqBggrBgEFBQcCAjAeGhxodHRwczovL3d3dy52ZXJpc2ln
# bi5jb20vcnBhMA4GA1UdDwEB/wQEAwIBBjBtBggrBgEFBQcBDARhMF+hXaBbMFkw
# VzBVFglpbWFnZS9naWYwITAfMAcGBSsOAwIaBBSP5dMahqyNjmvDz4Bq1EgYLHsZ
# LjAlFiNodHRwOi8vbG9nby52ZXJpc2lnbi5jb20vdnNsb2dvLmdpZjA0BgNVHR8E
# LTArMCmgJ6AlhiNodHRwOi8vY3JsLnZlcmlzaWduLmNvbS9wY2EzLWc1LmNybDA0
# BggrBgEFBQcBAQQoMCYwJAYIKwYBBQUHMAGGGGh0dHA6Ly9vY3NwLnZlcmlzaWdu
# LmNvbTAdBgNVHSUEFjAUBggrBgEFBQcDAgYIKwYBBQUHAwMwKAYDVR0RBCEwH6Qd
# MBsxGTAXBgNVBAMTEFZlcmlTaWduTVBLSS0yLTgwHQYDVR0OBBYEFM+Zqep7JvRL
# yY6P1/AFJu/j0qedMB8GA1UdIwQYMBaAFH/TZafC3ey78DAJ80M5+gKvMzEzMA0G
# CSqGSIb3DQEBBQUAA4IBAQBWIuY0pMRhy0i5Aa1WqGQP2YyRxLvMDOWteqAif99H
# OEotbNF/cRp87HCpsfBP5A8MU/oVXv50mEkkhYEmHJEUR7BMY4y7oTTUxkXoDYUm
# cwPQqYxkbdxxkuZFBWAVWVE5/FgUa/7UpO15awgMQXLnNyIGCb4j6T9Emh7pYZ3M
# sZBc/D3SjaxCPWU21LQ9QCiPmxDPIybMSyDLkB9djEw0yjzY5TfWb6UgvTTrJtmu
# DefFmvehtCGRM2+G6Fi7JXx0Dlj+dRtjP84xfJuPG5aexVN2hFucrZH6rO2Tul3I
# IVPCglNjrxINUIcRGz1UUpaKLJw9khoImgUux5OlSJHTMYICazCCAmcCAQEwgckw
# gbQxCzAJBgNVBAYTAlVTMRcwFQYDVQQKEw5WZXJpU2lnbiwgSW5jLjEfMB0GA1UE
# CxMWVmVyaVNpZ24gVHJ1c3QgTmV0d29yazE7MDkGA1UECxMyVGVybXMgb2YgdXNl
# IGF0IGh0dHBzOi8vd3d3LnZlcmlzaWduLmNvbS9ycGEgKGMpMTAxLjAsBgNVBAMT
# JVZlcmlTaWduIENsYXNzIDMgQ29kZSBTaWduaW5nIDIwMTAgQ0ECEA/jnfqesdrv
# mt0EbCZZZoowCQYFKw4DAhoFAKB4MBgGCisGAQQBgjcCAQwxCjAIoAKAAKECgAAw
# GQYJKoZIhvcNAQkDMQwGCisGAQQBgjcCAQQwHAYKKwYBBAGCNwIBCzEOMAwGCisG
# AQQBgjcCARUwIwYJKoZIhvcNAQkEMRYEFByuhbjcyTDhMweLHfGVXwN4OaBNMA0G
# CSqGSIb3DQEBAQUABIIBAFTsPpwGOvJhi77A3gZh6H5wLP2MASTwHji+4fHefxRK
# RyXWIB6outqWyXtFhBYf7tQwTHWbzrhTIPPuVBdYkwkHW/MSOo8a0W318eNvEpkY
# mcttpgVf7qiSoJanqz0zw3D2vA8bWOagRxJWznFJ2G6N1ltF6AspBX2D/EkjoD5j
# ++wuRYWrAKTtcwFdol39on4AkCVVSNAQfP7m/YmlKSkZx6dK1hQqTXAUt9Rw7JhV
# Iq2w0o3hIRxRf+A4k0Heirq7cvX3bQ7wjaM55J15x6usyl8Hx3kKLJSuyzjcd7ST
# Dkh2uAqkopu9oFHRiajug76Wbu5Ojl9orDjPluQgHvs=
# SIG # End signature block
